#
# Copyright (c) 2013 Duo Security
# All Rights Reserved
#


ENCRYPT_PLAIN = 0
ENCRYPT_AES256CFB = 1
ENCRYPT_TYPES = set((ENCRYPT_PLAIN, ENCRYPT_AES256CFB))


def secure_compare(str1, str2):
    """
    Data-independent comparison for fixed-length secrets.

    WARNING: Do _NOT_ use for comparisons where length is unknown by the
    attacker (eg. for passwords), but only use for fixed-length comparisons
    like an HMAC.

    There's lots of subtleties here...Python 3.x will have a proper version
    written in C analogous to BSD's timingsafe_bcmp(3).
    """
    bytes1 = bytearray(str(str1))
    bytes2 = bytearray(str(str2))

    if len(bytes1) != len(bytes2):
        return False

    result = 0
    for x, y in zip(bytes1, bytes2):
        result |= x ^ y

    return result == 0
