#!/usr/bin/env python
#
# grep for use of dangerous enc_trusted pattern for json encoding.
#
# any new uses of enc_trusted need to be carefully reviewed and whitelisted by security@.
#
# ask jono@ if you have any questions.
#

import os
import sys
import commands

SRC = os.environ.get('SRC', '.')
EXCEPTIONS = [
]


def main():
    print 'checking for dangerous enc_trusted usage...'

    # check for dangerous enc_trusted
    cmd = (
        'find {0} '
        '-path "*/.svn" -prune -o '
        '-path {0}/dist -prune -o '
        '-path {0}/duoauthproxy-build -prune -o '
        '-path {0}/third-party -prune -o '
        '-path {0}/test -prune -o '
        '-type f -print | xargs grep -E -H -n "func=strutil.enc_trusted"'
        .format(SRC)
    )
    print cmd
    status, output = commands.getstatusoutput(cmd)
    status = os.WEXITSTATUS(status)

    for line in output.splitlines():
        path, _ = line.split(':', 1)

        if path not in EXCEPTIONS:
            err(output)
            err('unexpected and potentially dangerous use of enc_trusted! ask security@ for review!')
            sys.exit(1)

        EXCEPTIONS.remove(path)

    print 'OK!'


def err(msg):
    sys.stderr.write(msg)
    sys.stderr.write('\n')


if __name__ == '__main__':
    main()
