#!/usr/bin/env python
#
# grep for use of dangerous yaml usage.
#
# we should never use yaml. it enables code execution similar to pickle.
#
# ask jono@/security@ if you have any questions.
#

import os
import sys
import commands


def main():
    print 'checking for dangerous YAML usage...'

    # check for PyYAML imports or yaml.load calls
    cmd = (
        'find {0} '
        '-path "*/.svn" -prune -o '
        '-path "*/.git" -prune -o '
        '-path {0}/dist -prune -o '
        '-path {0}/duoauthproxy-build -prune -o '
        '-path {0}/third-party -prune -o '
        '-path {0}/test -prune -o '
        '-type f -print '
        '| xargs grep -i -E -H -n "import yaml|yaml.load"'
        .format(os.environ.get('SRC', '.'))
    )
    print cmd
    status, output = commands.getstatusoutput(cmd)
    status = os.WEXITSTATUS(status)

    for line in output.splitlines():
        path, _ = line.split(':', 1)

        err(output)
        err('unexpected and potentially dangerous use of yaml! ask security@ for review!')
        sys.exit(1)

    print 'OK!'


def err(msg):
    sys.stderr.write(msg)
    sys.stderr.write('\n')


if __name__ == '__main__':
    main()
