Feature: Failmode
  Scenario Outline: ldap_server_auto failmodes
    Given a config with failmode of <failmode>
    And a config with api_host of badhost.local.duo
    And the authproxy is started with a ad_client and ldap_server_auto config
    When an ldap client authentication request is initiated for Fred Person
    Then  in the authproxy logs we should see <result>

  Examples: Fail Safe & Fail Secure
    | failmode | result                                                  |
    | safe     | "Failmode Safe - Allowed Duo login on preauth failure"  |
    | secure   | "Failmode Secure - Denied Duo login on preauth failure" |

  Scenario Outline: radius_server_auto failmodes
    Given a config with failmode of <failmode>
    And a config with api_host of badhost.local.duo
    And the authproxy is started with a ad_client and radius_server_auto config
    When a radius client authentication request is initiated for fred
    Then  in the authproxy logs we should see <result>

  Examples: Fail Safe & Fail Secure
    | failmode | result                                                  |
    | safe     | "Failmode Safe - Allowed Duo login on preauth failure"  |
    | secure   | "Failmode Secure - Denied Duo login on preauth failure" |

  Scenario Outline: radius_duo_only failmodes
    Given a config with failmode of <failmode>
    And a config with api_host of badhost.local.duo
    And the authproxy is started with a radius_server_duo_only config
    When a radius client authentication request is initiated for fred
    Then  in the authproxy logs we should see <result>

  Examples: Fail Safe & Fail Secure
    | failmode | result                                                  |
    | safe     | "Failmode Safe - Allowed Duo login on preauth failure"  |
    | secure   | "Failmode Secure - Denied Duo login on preauth failure" |

  Scenario Outline: radius_server_concat failmodes
    Given a config with failmode of <failmode>
    And a config with api_host of badhost.local.duo
    And the authproxy is started with a radius_server_concat config
    When a concat radius client authentication request is initiated for fred
    Then  in the authproxy logs we should see <result>

  Examples: Fail Safe & Fail Secure
    | failmode | result                                                  |
    | safe     | "Failmode Safe - Allowed Duo login on preauth failure"  |
    | secure   | "Failmode Secure - Denied Duo login on preauth failure" |

  Scenario Outline: radius_server_challenge failmodes
    Given a config with failmode of <failmode>
    And a config with api_host of badhost.local.duo
    And the authproxy is started with a radius_server_challenge config
    When a radius client authentication request is initiated for fred
    Then  in the authproxy logs we should see <result>

  Examples: Fail Safe & Fail Secure
    | failmode | result                                                  |
    | safe     | "Failmode Safe - Allowed Duo login on preauth failure"  |
    | secure   | "Failmode Secure - Denied Duo login on preauth failure" |

  Scenario Outline: radius_server_iframe failmodes
    Given a config with failmode of <failmode>
    And a config with api_host of badhost.local.duo
    And the authproxy is started with a radius_server_iframe config
    When a radius client authentication request is initiated for fred
    Then  in the authproxy logs we should see <result>

  Examples: Fail Safe & Fail Secure
    | failmode | result                                                  |
    | safe     | "Failmode Safe - Allowed Duo login on preauth failure"  |
    | secure   | "Failmode Secure - Denied Duo login on preauth failure" |
