"""
This module contains wrappers around small twisted clients to be used as applications for testing proxying.
Behave has no support for Twisted so this allows us to run them without blocking the main behave process.
"""
import os
import subprocess


def run_radius_client(context, username, concat="no"):
    script_path = os.path.abspath(os.path.join(os.path.dirname(__file__), 'radius_client.py'))
    subprocess.call([context.installer.authproxy_python, script_path, username, concat])


def run_ldap_client(context, username):
    script_path = os.path.abspath(os.path.join(os.path.dirname(__file__), 'ldap_client.py'))
    subprocess.call([context.installer.authproxy_python, script_path, username])
