from sys import argv

from twisted.internet import defer
from twisted.internet import task

from ldaptor.protocols.ldap import ldapclient, ldapconnector


@task.react
@defer.inlineCallbacks
def main(reactor):
    """
    Set up a LDAPClient which initiates the call to the LDAP server which kicks
    off the 2fa process. This is configured in the AP's `ldap_server_auto` section.
    """
    username = argv[1]

    base_dn = 'CN=Users,dc=bongos,dc=test'
    bind_dn = 'CN={0!s},CN=Users,DC=bongos,DC=test'.format(username)
    bind_pw = 'pass2word'

    c = ldapconnector.LDAPClientCreator(reactor, ldapclient.LDAPClient)

    overrides = {base_dn: ('127.0.0.1', 389)}

    client = yield c.connect(base_dn, overrides=overrides)

    yield client.bind(bind_dn, bind_pw)
