from sys import argv

from twisted.internet import defer
from twisted.internet import task

from duoauthproxy.lib.config_provider import ConfigDict
from duoauthproxy.modules import radius_client


@task.react
@defer.inlineCallbacks
def main(reactor):
    """ Make a 'client' that sends a simple auth packet to the proxy."""
    username = argv[1]
    concat = argv[2]

    if concat == 'yes':
        password = 'pass2word,push'
    else:
        password = 'pass2word'

    calling_station_id = '127.0.0.1'

    config_items = {
        'host': '127.0.0.1',
        'secret': 's3cr3t',
    }
    config = ConfigDict(config_items)
    instance = radius_client.Module(config)
    instance.startService()

    yield instance.authenticate(username, password, calling_station_id)
