Feature: Primary Only Mode
  Scenario: Starting in Primary Mode
    Given the authproxy is started in primary only mode with a ad_client and radius_server_auto config
    Then in the authproxy logs we should see "Running in PRIMARY ONLY mode. Stopping in 1 minutes"


  Scenario Outline: LDAP Server Auto
    Given a config with failmode of <failmode>
    And the authproxy is started in primary only mode with a ad_client and ldap_server_auto config
    When an ldap client authentication request is initiated for Fred Person
    Then in the authproxy logs we should see <fail_message>
    And in the authproxy logs we should see <response_to_client>

  Examples: Fail Safe & Fail Secure
    | failmode | fail_message | response_to_client |
    | safe     | "Primary Only Mode - Secondary authentication bypassed" | "S->C LDAPMessage(id=1L, value=LDAPBindResponse(resultCode=0L" |
    | secure   | "Failmode Secure - Denied Duo login on preauth failure" | "S->C LDAPMessage(id=1L, value=LDAPBindResponse(resultCode=49, errorMessage='Failmode Secure - Denied Duo login on preauth failure'))" |


  Scenario Outline: Radius Server Auto
    Given a config with failmode of <failmode>
    And the authproxy is started in primary only mode with a ad_client and radius_server_auto config
    When a radius client authentication request is initiated for fred
    Then in the authproxy logs we should see <fail_message>
    And in the authproxy logs we should see <response_to_client>

  Examples: Fail Safe & Fail Secure
    | failmode | fail_message | response_to_client |
    | safe     | "Primary Only Mode - Secondary authentication bypassed" | "Returning response code 2: AccessAccept" |
    | secure   | "Failmode Secure - Denied Duo login on preauth failure" | "Returning response code 3: AccessReject" |


  Scenario Outline: Radius Duo Only
    Given a config with failmode of <failmode>
    And the authproxy is started in primary only mode with a radius_server_duo_only config
    When a radius client authentication request is initiated for fred
    Then in the authproxy logs we should see <fail_message>
    And in the authproxy logs we should see <response_to_client>

  Examples: Fail Safe & Fail Secure
    | failmode | fail_message | response_to_client |
    | safe     | "Primary Only Mode - Secondary authentication bypassed" | "Returning response code 2: AccessAccept" |
    | secure   | "Failmode Secure - Denied Duo login on preauth failure" | "Returning response code 3: AccessReject" |


  Scenario Outline: Radius Concat
    Given a config with failmode of <failmode>
    And the authproxy is started in primary only mode with a radius_server_concat config
    When a concat radius client authentication request is initiated for fred
    Then in the authproxy logs we should see <fail_message>
    And in the authproxy logs we should see <response_to_client>

  Examples: Fail Safe & Fail Secure
    | failmode | fail_message | response_to_client |
    | safe     | "Primary Only Mode - Secondary authentication bypassed" | "Returning response code 2: AccessAccept" |
    | secure   | "Failmode Secure - Denied Duo login on preauth failure" | "Returning response code 3: AccessReject" |


  Scenario Outline: Radius Challenge
    Given a config with failmode of <failmode>
    And the authproxy is started in primary only mode with a radius_server_challenge config
    When a radius client authentication request is initiated for fred
    Then in the authproxy logs we should see <fail_message>
    And in the authproxy logs we should see <response_to_client>

  Examples: Fail Safe & Fail Secure
    | failmode | fail_message | response_to_client |
    | safe     | "Primary Only Mode - Secondary authentication bypassed" | "Returning response code 2: AccessAccept" |
    | secure   | "Failmode Secure - Denied Duo login on preauth failure" | "Returning response code 3: AccessReject" |


  Scenario Outline: Radius Iframe
    Given a config with failmode of <failmode>
    And the authproxy is started in primary only mode with a radius_server_iframe config
    When a radius client authentication request is initiated for fred
    Then in the authproxy logs we should see <fail_message>
    And in the authproxy logs we should see <response_to_client>

  Examples: Fail Safe & Fail Secure
    | failmode | fail_message | response_to_client |
    | safe     | "Primary Only Mode - Secondary authentication bypassed" | "Returning response code 2: AccessAccept" |
    | secure   | "Failmode Secure - Denied Duo login on preauth failure" | "Returning response code 3: AccessReject" |
