import os
import base64
import subprocess
from behave import given, when, then


def is_base64_string(s):
    try:
        base64.b64decode(s)
        return True
    except Exception:
        return False


@given('we are working in the install directory')
def step_impl(context):
    os.chdir(context.installer.install_dir)


@when('authproxy_passwd is run with no arguments')
def step_impl(context):
    context.secret = subprocess.check_output(['bin/authproxy_passwd.exe', 'thisisatestpassword'])


@when('authproxy_passwd is run with arguments "{args}"')
def step_impl(context, args):
    if args != "no arguments":
        args_array = args.split(' ')
    else:
        args_array = []
    context.secret = subprocess.check_output(['bin/authproxy_passwd.exe'] + args_array)


@then('we should get back the encrypted password')
def step_impl(context):
    assert is_base64_string(context.secret)


def check_secret(line):
    try:
        key, val = line.split('=', 1)
        if key.find("secret") != -1:
            assert key.find("_protected") and is_base64_string(val)
    except ValueError:
        # if we get a `split` error from a non-key-value line then we just
        # keep going
        pass


@then('we should get back an encrypted config')
def step_impl(context):
    with open(context.installer.conf_file) as config_handle:
        for line in config_handle.read():
            check_secret(line)
