# pylint: disable=W0613,E0102,E0611
# flake8: noqa: F811

import os

from platform import system
from behave import given, when

from test.features.fixtures import configs
from test.features.fixtures.clients.clients import run_ldap_client, run_radius_client


@when('an ldap client authentication request is initiated for {username}')
def step_def(context, username):
    """
    Runs an LDAP client that performs a 2FA
    """
    run_ldap_client(context, username)


@when('a radius client authentication request is initiated for {username}')
def step_def(context, username):
    """
    Runs a RADIUS client that performs a 2FA
    """
    run_radius_client(context, username)

@when('a concat radius client authentication request is initiated for {username}')
def step_def(context, username):
    """
    Runs a RADIUS client that performs a 2FA
    """
    run_radius_client(context, username, concat="yes")

@given(u'we expect a valid authentication')
def step_impl(context):
    raise NotImplementedError(u'boop')
