What's in here / What we test
===========================
This directory contains:
  - Mock objects used for testing purposes only
  - Tests for all server module classes (residing in duoauthproxy/modules)
  - Tests for lower-level stuff like mppe keygen and ssl verification


How tests are run
=================
A `make test` will:
  - install the Auth Proxy and its Python dependencies via `make dist` (== make all)
    which runs `make proxy` (installs twisted, pymox, and several other packages)
    and installs the authproxy/duoauthproxy service
  - install the PyMox package for testing via `make pymox`
  - automatically run all tests present in /test/lib via Twisted's trial and unittest
    (`python test` runs all tests it can find in test/)
    - unittest will run any test function starting with "test"


What about test_client.py and test_server.py?
=============================================
While we do have unit tests, you can test manually against the AP by using these two files.
Both files don't make use of any AP-specific code; rather, it assumes you've got an
already running instance of the duoauthproxy service and leverages that instead.

The duoauthproxy service started by `service` will read the configuration file in
/opt/duoauthproxy/conf/authproxy.cfg, so be sure your config file has the proper fields
filled out. (Check /opt/duoauthproxy/log/authproxy.log if starting the service keeps failing
and you're definitely using sudo- it'll complain that it can't read the conf file if you
forget sudo.)

When running test_client.py, you can give any username to the program. Based on
your IKEY/SKEY it will look for your RADIUS/LDAP integration that you made in the admin panel.
Giving test_client a user not present under your Duo First account will prompt you for
enrollment, depending on what kind of server you're using.

The password is simply "password" (no quotes) as per test_server.py.

To test,
sudo service duoauthproxy start # need sudo to be able to read authproxy.cfg
/usr/bin/python2.6 test_server & # to run in background
/opt/duoauthproxy/bin/python2.6 test_client.py # runs in foreground interactively

tail -F /opt/duoauthproxy/log/authproxy.log # look at logs as they're made