import sys
from unittest.case import _ExpectedFailure, _UnexpectedSuccess
from decorator import decorator
from twisted.internet import defer

from duoauthproxy.lib import fips_manager


def raiseUnexpectedSuccess():
    raise _UnexpectedSuccess


def raiseExpectedFailure(reason=None):
    # unfortunately for deferred callbacks this may not be possible
    # we just have to succeed rather than mark an expected failure
    return


@decorator
def expectFIPSFailure(f, *args, **kw):
    if fips_manager.status():
        try:
            val = f(*args, **kw)
            if isinstance(val, defer.Deferred):
                return val.addCallbacks(raiseUnexpectedSuccess, errback=raiseExpectedFailure)
        except Exception:
            raise _ExpectedFailure(sys.exc_info())
        raise _UnexpectedSuccess
    else:
        return f(*args, **kw)
