#
# Copyright (c) 2012 Duo Security
# All Rights Reserved
#
from pyrad import packet

from duoauthproxy.lib.base import AuthResult
from duoauthproxy.lib.radius.base import radius_dictionary

from base import TestCase


class TestAuthResult(TestCase):
    def test_from_radius_packet_success(self):
        response_packet = packet.AuthPacket(packet.AccessAccept,
                                            dict=radius_dictionary())
        msg = 'Hello, World!'
        response_packet['Reply-Message'] = msg
        auth_result = AuthResult.from_radius_packet(response_packet)
        self.assertTrue(auth_result.success)
        self.assertEqual(auth_result.msg,
                         msg)
        self.assertIs(auth_result.response,
                      response_packet)

    def test_from_radius_packet_fail(self):
        response_packet = packet.AuthPacket(packet.AccessReject,
                                            dict=radius_dictionary())
        msg = 'Hello, World!'
        response_packet['Reply-Message'] = msg
        auth_result = AuthResult.from_radius_packet(response_packet)
        self.assertFalse(auth_result.success)
        self.assertEqual(auth_result.msg,
                         msg)
        self.assertIs(auth_result.response,
                      response_packet)
