import unittest
from duoauthproxy.lib.random_wrapper import _duo_urandom_new_wrapper


class DefaultWrapRandomTestCase(unittest.TestCase):
    def test_urandom_returns_a_string(self):
        result = _duo_urandom_new_wrapper(3)
        self.assertIsInstance(result, str)

    def test_urandom_result_is_requested_length(self):
        length_1 = 4
        result_1 = _duo_urandom_new_wrapper(length_1)

        self.assertEqual(len(result_1), length_1)

        length_2 = 100
        result_2 = _duo_urandom_new_wrapper(length_2)

        self.assertEqual(len(result_2), length_2)

    def test_urandom_sanity_check(self):
        """We can't ensure the results are random, so check that the return changes."""
        # The chances of two random bit streams of this length being the same
        # are unimaginably small.
        length = 10000
        result_1 = _duo_urandom_new_wrapper(length)
        result_2 = _duo_urandom_new_wrapper(length)

        self.assertNotEqual(result_1, result_2)
