# -*- coding: utf-8 -*-
import textwrap
from base import TestCase
from duoauthproxy.lib import config_provider


class TestUnicodeConfig(TestCase):
    GOOD_CONFIG = textwrap.dedent("""
        ; This config is property of ☃
        # This config is property of ❄️
        REM This config is property of ⛸
        [main]
        log_file=/tmp/εβδομάδα.log ; εβδομάδα means "week"

        [cloud]
        service_account_username=jääärna
        service_account_password=123sfärrrje!

        [http_proxy]
        host=نطاق.السعودية.com
        המפתח=key
    """)

    def test_parse_config(self):
        expected_result = ['main',
                           'cloud',
                           'http_proxy',
                           ]
        config_string = self.GOOD_CONFIG
        cp = config_provider.ConfigProvider(config_string)
        actual_result = cp.list_sections()
        self.assertItemsEqual(expected_result, actual_result)
