#
# Copyright (c) 2011 Duo Security
# All Rights Reserved
#

import unittest
from duoauthproxy.lib import fips_manager


class MetaTester(object):
    cached_suite = False

    @staticmethod
    def run_in_fips_mode(module, test, runner=unittest.TextTestRunner()):
        print 'Running tests in FIPS mode'
        fips_manager.enable()
        suite = MetaTester._get_suite(module, test)
        return runner.run(suite).wasSuccessful()

    @staticmethod
    def run_in_non_fips_mode(module, test, runner=unittest.TextTestRunner()):
        print 'Running tests in non-FIPS mode'
        suite = MetaTester._get_suite(module, test)
        return runner.run(suite).wasSuccessful()

    @staticmethod
    def _get_suite(module, test):
        unittest.signals.installHandler()
        if module:
            if test:
                return unittest.defaultTestLoader.loadTestsFromName(test, module)
            return unittest.defaultTestLoader.loadTestsFromModule(module)

        if not MetaTester.cached_suite:
            MetaTester.cached_suite = unittest.TestLoader().discover(start_dir='test')
        return MetaTester.cached_suite
